// Code scaffolded by goctl. Safe to edit.
// goctl 1.9.2

package shop

import (
	"context"
	"errors"

	"juwan-backend/app/shop/api/internal/svc"
	"juwan-backend/app/shop/api/internal/types"
	"juwan-backend/common/utils/contextj"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetMyShopLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

// 获取当前用户的店铺
func NewGetMyShopLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetMyShopLogic {
	return &GetMyShopLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *GetMyShopLogic) GetMyShop(req *types.EmptyResp) (resp *types.ShopProfile, err error) {
	userID, err := contextj.UserIDFrom(l.ctx)
	if err != nil {
		return nil, err
	}

	shop, err := getShopByOwnerID(l.ctx, l.svcCtx.ShopRpc, userID)
	if err != nil {
		return nil, err
	}
	if shop == nil {
		return nil, errors.New("shop not found")
	}

	return toShopProfile(shop), nil

}
